import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import math
import random
import sys
import os
import numpy as np

mean_Dense = [0.1756493342302373,0.19945828247027608,1.7699356980656111,0.47316399380254087,0.32388114863815703,0.24617013548145522,0.2168395291885773,0.2255561313115341,0.2872141057524275,0.32802138025753746,0.24617772172304736,0.3252910771154563,0.37253971643187495,0.4066004207356347,0.37923188061916135,0.2938325187740603,0.3577326652588812,0.416110509102487,0.4383442088681911,0.36255145110319825]
std_Dense = [0.197174908402,0.249649047639,1.06456266434,0.178458819865,0.243936285338,0.195184613702,0.178467781553,0.158780392336,0.18442783735,0.416367303882,0.20654829751,0.285333234134,0.302157184973,0.415518000554,0.270212138707,0.298877809088,0.329914397828,0.293973345538,0.247848654548,0.324540460067]

mean_GRU = [0.17308784721288392,0.16666282857167747,0.3140948472988019,0.2471707999573129,0.3515422151608493,0.1887180155422053,0.26967394299577385,0.3669164452057088,0.5112889404220226,0.28580346168425513,0.2956741264837981,0.34331735164474814,0.35005985902473685,0.229828046231912,0.3174720223259873,0.25322465143575185,0.36876300947694085,0.25887160664658004,0.25991001180182494,0.3065292237689415]
std_GRU = [0.233316464038,0.213782429862,0.162811457599,0.13464431577,0.32067060255,0.126916541896,0.174239168461,0.267739531002,0.392321247913,0.259837050057,0.24914690836,0.274860040625,0.310594225817,0.182024916377,0.223340678015,0.192037916804,0.283757419159,0.184940399471,0.194284393356,0.244599678911]

chosen_subset_Dense = 7
chosen_subset_GRU = 5

fig = plt.figure()
#fig.set_figheight(4)
#fig.set_figwidth(4)
plt.subplot(1,1,1)
xs = np.arange(len(mean_GRU))
#plt.axvline(x=chosen_subset_Dense, color='g', linestyle='--')
#(_, caps, _) = plt.errorbar(xs[3:], mean_Dense[3:], yerr=std_Dense[3:], fmt='o', capsize=5)
plt.axvline(x=chosen_subset_GRU, color='r', linestyle='--')
(_, caps2, _) = plt.errorbar(xs[3:], mean_GRU[3:], yerr=std_GRU[3:], fmt='o', capsize=5)
#for cap in caps:
#    cap.set_markeredgewidth(1)
for cap in caps2:
    cap.set_markeredgewidth(1)

plt.xticks(xs[3:], xs[3:]+1)
plt.title("Mean Absolute Error (MAE) vs\nnumber of features selected")
plt.xlabel("Number of features")
plt.ylabel("Mean Absolute Error ")
plt.legend(["Number of features\nselected for GRU", "Mean and Standard\nDeviation of MAE for GRU"], loc="upper center", ncol=4, mode="expand", borderaxespad=0.)
plt.tight_layout()
fig.savefig("accuracy_study.png")
